/*
******************************************************************************
** PEXlib Texture Mapping Test Code 
**
** $Source: /src/rcs/Cats/XSystem/pex/txm_utility_code/prototypes.h,v $
** $Revision: 510.1 $
** $Date: 94/02/26 10:42:33 $
** $Author: hmgr $
******************************************************************************
*/

/*
 *  THIS IS A PRELIMINARY VERSION!!
 */

/*
 * PROTOTYPES.H -- Function prototypes.
 *
 *                by Bradley L. Saunders     Nov. 16, 1993
 */

/******************************************************************************/
/*                                                                            */
/*  (c) Copyright Hewlett-Packard Company, 1993, Fort Collins, Colorado       */
/*                                                                            */
/*                            All Rights Reserved                             */
/*                                                                            */
/*  Permission to use, copy, modify, and distribute this software and its     */
/*  documentation for any purpose and without fee is hereby granted,          */
/*  provided that the above copyright notices appear in all copies and that   */
/*  both the copyright notices and this permission notice appear in           */
/*  supporting documentation, and that the name of Hewlett-Packard not be     */
/*  used in advertising or publicity pertaining to distribution of the        */
/*  software without specific, written prior permission.                      */
/*                                                                            */
/*  HEWLETT-PACKARD MAKES NO WARRANTY OF ANY KIND WITH REGARD TO THIS         */
/*  SOFTWARE, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF        */
/*  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  Hewlett-Packard    */
/*  shall not be liable for errors contained herein or direct, indirect,      */
/*  special, incidental or consequential damages in connection with the       */
/*  furnishing, performance or use of this software.                          */
/*                                                                            */
/******************************************************************************/

 /*
  * This list is not complete
  * BLS          Nov. 30, 1993
  */

 /*
  * Texuture_test.c
  */
void parse_error(int status);
void inquire_test_params(char *test_name,
                         int  *num_images,
                         int  *supported_modes,
                         char *win_title);
void testproc(Display *dpy, Window window, int cur_image);
int parse_options2 (int argc, char **argv, int *pexmode, int *image_depth,
    char *fname);
 
 /*
  * parser.c
  */
char *Clean_File(char *filename);
void Remove_Spaces(char *incoming);
void Remove_Comment(char *incoming);
void Remove_Mult_Entries(char *incoming);
void Error(char *err_str);
void Warning(char *warn_str);
void Get_Keyword_Value(char **file, char *, char *);
void Get_Value(char **file, char *value);
PEXEnumTypeIndex Convert_Enum(char *enum_str);
int Convert_Flags(char *value, char *keyword);
void Load_Do_Flags(char **file, Input_Parameters *in);
void Load_Initial_Information(char **file, Input_Parameters *in);
void Load_Map(PEXExtTexelArray *texture,
              PEXEnumTypeIndex texel_type,
              char *filename);
struct Point *store_coord(struct Point *list, float x, float y, float z);
void Load_Object(char *value, Input_Parameters *in, int obj);
void Load_Texture_Information(char **file, Input_Parameters *in);
void Load_Object_Information(char **file, Input_Parameters *in);
void Load_OC_Information(char **file, Input_Parameters *in);
void Load_Binding_LUT_Information(char **file, Input_Parameters *in);
void Load_CoordSource_LUT_Information(char **file, Input_Parameters *in);
void Load_Composition_LUT_Information(char **file, Input_Parameters *in);
void Load_Sampling_LUT_Information(char **file, Input_Parameters *in);
void Load_Rendering_Information(char **file, Input_Parameters *in);
unsigned short Convert_Clip_Flags(char *value);
void Load_Viewport_Information(char **file, Input_Parameters *in);
void Get_Color_Specifier(char **file, PEXColorSpecifier *color, char *keyword);
void Load_Lighting_Information(char **file, Input_Parameters *in);
PEXOCRequestType Get_Request_Type(char *value);
void Parse_File(char *filename, Input_Parameters *in);

 /*
  * utils.c
  */
void Copy_Data(char **data,
               PEXEnumTypeIndex texel_type,
               PEXExtTexelArray map,
               unsigned int *return_size);

void Put_Texture_In_Window(Display *dpy,
                           Input_Parameters *in,
                           int map,
                           int depth,
                           Window *rgbwin,
                           Window *alphawin);

void set_view(Display *dpy,
              PEXLookupTable view_table,
              Input_Parameters in);

void normalize(PEXVector *vector);
void set_lights(Display *dpy,
                PEXLookupTable light_table,
                Input_Parameters in,
                int *num_lights);
void set_depth_cue(Display *dpy,
                   PEXLookupTable depth_cue_table,
                   Input_Parameters in);
 /*
  * get_eunms.c
  */
void init_enums();
PEXEnumTypeIndex TEMP_Get_Enums(char *what);
